/*
   Siag, Scheme In A Grid
   Copyright (C) 2000  Ulric Eriksson <ulric@siag.nu>
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
 */

#include "../config.h"

#ifdef HAVE_LIBPQ

/* Highly experimental! */

#include <stdio.h>
#include <stdlib.h>
#include <libpq-fe.h>
#include "../siod/siod.h"
#include "calc.h"

static char *host = "127.0.0.1";
static char *database = "ulric";
static char *port = NULL;

static LISP store_result(buffer *buf, int sht, int row, int col,
		PGresult *pgres)
{
	int i, j, n;
	cval val;
	char *p;
	LISP res = NIL;
	ExecStatusType est;

	if (!pgres ||
	    ((est = PQresultStatus(pgres)) != PGRES_COMMAND_OK &&
	     est != PGRES_TUPLES_OK)) {
		fprintf(stderr, "%s\n", PQresultErrorMessage(pgres));
		PQclear(pgres);
		return NIL;
	}

	val.number = 0;
	n = PQnfields(pgres);

	for (i = 0; i < PQntuples(pgres); i++) {
		for (j = 0; j < n; j++) {
			p = PQgetvalue(pgres, i, j);
			if (res == NIL) {
				res = strcons(strlen(p), p);
			} else {
				ins_data(buf, siod_interpreter,
					p, val, MTEXT, sht, row+i, col+j);
			}
		}
	}
	PQclear(pgres);
	return res;
}

static LISP lpostgres_query(LISP query)
{
	char *pgoptions = NULL, *pgtty = NULL;
	PGconn *conn;
	PGresult *pgres;
	int row, col, sht;
	buffer *buf;
	char *q = get_c_string(query);
	LISP res;

	get_siod_coords(&row, &col, &sht, &buf);

	conn = PQsetdb(host, port, pgoptions, pgtty, database);

	if (PQstatus(conn) == CONNECTION_BAD) {
		fprintf(stderr, "Connection to database '%s' failed.\n",
			database);
		fprintf(stderr, "%s\n", PQerrorMessage(conn));
		PQfinish(conn);
		return NIL;
	}

	pgres = PQexec(conn, q);
	res = store_result(buf, sht, row, col, pgres);
	PQfinish(conn);
	return res;
}

void init_postgres(void)
{
	init_subr_1("postgres_query", lpostgres_query);
}

#else

void init_postgres(void)
{
	;
}

#endif	/* POSTGRES */

